/* 16F1829internal.h: 
 * Compiler: XC8 (v1.42) MPLABX (v4.15)
 * V1.0 - BENABADJI Noureddine - Oran - Feb. 08th, 2021
 */

#ifndef INTERNAL_HEADER_H
#define	INTERNAL_HEADER_H

/*******************************************************************************
 *Includes and defines
 ******************************************************************************/
// PIC16F1829 Configuration Bit Settings

// CONFIG1
#pragma config FOSC = INTOSC   // Oscillator Selection Bits (INTOSC oscillator: I/O function on CLKIN pin)
//#pragma config WDTE = ON      // Watchdog Timer Enable (WDT enabled)
//#pragma config WDTE = OFF      // Watchdog Timer Enable (WDT disabled)
#pragma config WDTE = SWDTEN     // Watchdog control by the SWDTEN bit of WDTCON register
#pragma config PWRTE = OFF     // Power-up Timer Enable (PWRT disabled)
#pragma config MCLRE = OFF     // MCLR Pin Function Select (MCLR/VPP pin function is RA3 input)
#pragma config CP = OFF        // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config BOREN = OFF     // Brown-out Reset Enable (Brown-out Reset disabled)
#pragma config CLKOUTEN = OFF  // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = ON       // Internal/External Switchover Mode (Internal/External Switchover Mode is enabled)
#pragma config FCMEN = OFF     // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is enabled)

// CONFIG2
#pragma config WRT = OFF       // Flash Memory Self-Write Protection (Write protection off)
//#pragma config PPS1WAY = ON   // Peripheral Pin Select one-way control (The PPSLOCK bit cannot be cleared once it is set by software)
//#pragma config ZCDDIS = ON    // Zero-cross detect disable (Zero-cross detect circuit is disabled at POR and can be enabled with ZCDSEN bit.)
#pragma config PLLEN = OFF     // Phase Lock Loop enable (4x PLL is enabled when software sets the SPLLEN bit)
#pragma config STVREN = ON     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will cause a Reset)
#pragma config BORV = LO       // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
//#pragma config LPBOR = OFF    // Low-Power Brown Out Reset (Low-Power BOR is disabled)
#pragma config LVP = OFF       // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)

//XC8 Includes
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>
#include <math.h>

//For delay routines
#define _XTAL_FREQ 16000000
//#define _XTAL_FREQ 8000000

#define  DC    LATC2  //LATB5      
#define  RES   LATC3  //LATB7  
#define  CS    LATC6

//--------------------------------------------------------------------------
//Internal oscillator setup
//void internal_32();
void internal_16(); //16 MHz
//void internal_8();
//void internal_4();
//void internal_2();
//void internal_1();
//void internal_31(); //31 kHz

#endif	//INTERNAL_HEADER_H

